/*****************************************************************************
 *
 * MODULE:             OS Tutorial
 *
 * COMPONENT:          app_os_tutorial.c
 *
 * AUTHOR:             RCLAY
 *
 * DESCRIPTION:        OS TUrutorial Application
 *
 * $HeadURL: https://www.collabnet.nxp.com/svn/lprf_sware/Projects/User_Doc/User_Guides/UG3075/Trunk/Examples/JN-UG-3075-OS-Tutorial/OSTutorialOne/Source/app_os_tutorialOne.c $
 *
 * $Revision: 49860 $
 *
 * $LastChangedBy: nxp29772 $
 *
 * $LastChangedDate: 2012-11-23 13:47:54 +0000 (Fri, 23 Nov 2012) $
 *
 * $Id: app_os_tutorialOne.c 49860 2012-11-23 13:47:54Z nxp29772 $
 *
 *****************************************************************************
 *
 * This software is owned by Jennic and/or its supplier and is protected
 * under applicable copyright laws. All rights are reserved. We grant You,
 * and any third parties, a license to use this software solely and
 * exclusively on Jennic products. You, and any third parties must reproduce
 * the copyright and warranty notice and any other legend of ownership on each
 * copy or partial copy of the software.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS". JENNIC MAKES NO WARRANTIES, WHETHER
 * EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE,
 * ACCURACY OR LACK OF NEGLIGENCE. JENNIC SHALL NOT, IN ANY CIRCUMSTANCES,
 * BE LIABLE FOR ANY DAMAGES, INCLUDING, BUT NOT LIMITED TO, SPECIAL,
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON WHATSOEVER.
 *
 * Copyright Jennic Ltd 2009. All rights reserved
 *
 ****************************************************************************/

/****************************************************************************/
/***        Include files                                                 ***/
/****************************************************************************/

#include <jendefs.h>
#include "os.h"
#include "os_gen.h"
#include "dbg.h"
#include "AppHardwareApi.h"

#ifdef DK4
#include "GenericBoard.h"
#else
#include "ledcontrol.h"
#endif

#include "app_os_tutorial.h"

/****************************************************************************/
/***        Macro Definitions                                             ***/
/****************************************************************************/


#ifndef TRACE_APP
#define TRACE_APP	TRUE
#endif

#define RESTART_TIME    APP_TIME_MS(1000)

/****************************************************************************/
/***        Type Definitions                                              ***/
/****************************************************************************/

/****************************************************************************/
/***        Local Function Prototypes                                     ***/
/****************************************************************************/
PRIVATE void vDelayMsec(uint32 u32Period);

/****************************************************************************/
/***        Exported Variables                                            ***/
/****************************************************************************/

/****************************************************************************/
/***        Local Variables                                               ***/
/****************************************************************************/

/****************************************************************************/
/***        Exported Functions                                            ***/
/****************************************************************************/


/****************************************************************************
 *
 * NAME: APP_taskLed
 *
 * DESCRIPTION:
 * Main state machine for the home sensor demo coordinator
 *
 * RETURNS:
 * void
 *
 ****************************************************************************/
OS_TASK(APP_taskLedFlash)
{
    static bool bLedState = OFF;
    DBG_vPrintf(TRACE_APP, "Led Task\n");

    bLedState = ~bLedState;
    SET_LED(LED0,bLedState);

    // Waste some time
    vDelayMsec(500);

    OS_eActivateTask(APP_taskLedFlash);
	DBG_vPrintf(TRACE_APP, "Terminating task\n");
}

PRIVATE void vDelayMsec(uint32 u32Period)
{
    uint32 i, k;
    const uint32 u32MsecCount = 1800;
    volatile uint32 j;
    /* declare as volatile so compiler doesnt optimise increment away */

    for (k = 0; k < u32Period; k++)
        for (i = 0; i < u32MsecCount; i++) j++;
}

/****************************************************************************
 *
 * NAME: APP_isrSystem Controller
 *
 * DESCRIPTION:
 * ISR - Handles interrupts from Comparators, Wake Timers and Dio pins
 *
 * RETURNS:
 * void
 *
 ****************************************************************************/
OS_ISR(APP_isrSystemController)
{
    /*
     * ISR handles Wake Timer, Comparator and Dio interrupts
     */
    // Clear pending interrupt flags
    (void)u8AHI_WakeTimerFiredStatus();
    (void)u8AHI_ComparatorWakeStatus();
    (void)u32AHI_DioWakeStatus();
}


/****************************************************************************/
/***        Local Functions                                               ***/
/****************************************************************************/

/****************************************************************************/
/***        END OF FILE                                                   ***/
/****************************************************************************/
