/*****************************************************************************
 *
 * MODULE:             OS Tutorial
 *
 * COMPONENT:          app_os_tutorial.c
 *
 * AUTHOR:             RCLAY
 *
 * DESCRIPTION:        OS TUrutorial Application
 *
 * $HeadURL: https://www.collabnet.nxp.com/svn/lprf_sware/Projects/User_Doc/User_Guides/UG3075/Trunk/Examples/JN-UG-3075-OS-Tutorial/OSTutorialTwo/Source/app_os_tutorialTwo.c $
 *
 * $Revision: 49860 $
 *
 * $LastChangedBy: nxp29772 $
 *
 * $LastChangedDate: 2012-11-23 13:47:54 +0000 (Fri, 23 Nov 2012) $
 *
 * $Id: app_os_tutorialTwo.c 49860 2012-11-23 13:47:54Z nxp29772 $
 *
 *****************************************************************************
 *
 * This software is owned by Jennic and/or its supplier and is protected
 * under applicable copyright laws. All rights are reserved. We grant You,
 * and any third parties, a license to use this software solely and
 * exclusively on Jennic products. You, and any third parties must reproduce
 * the copyright and warranty notice and any other legend of ownership on each
 * copy or partial copy of the software.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS". JENNIC MAKES NO WARRANTIES, WHETHER
 * EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE,
 * ACCURACY OR LACK OF NEGLIGENCE. JENNIC SHALL NOT, IN ANY CIRCUMSTANCES,
 * BE LIABLE FOR ANY DAMAGES, INCLUDING, BUT NOT LIMITED TO, SPECIAL,
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON WHATSOEVER.
 *
 * Copyright Jennic Ltd 2009. All rights reserved
 *
 ****************************************************************************/

/****************************************************************************/
/***        Include files                                                 ***/
/****************************************************************************/

#include <jendefs.h>
#include "os.h"
#include "os_gen.h"
#include "dbg.h"
#include "AppHardwareApi.h"
#include "app_timer_driver.h"

#ifdef DK4
#include "GenericBoard.h"
#else
#include "ledcontrol.h"
#endif

#include "app_os_tutorial.h"

/****************************************************************************/
/***        Macro Definitions                                             ***/
/****************************************************************************/


#ifndef TRACE_APP
#define TRACE_APP	TRUE
#endif


/****************************************************************************/
/***        Type Definitions                                              ***/
/****************************************************************************/

/****************************************************************************/
/***        Local Function Prototypes                                     ***/
/****************************************************************************/

/****************************************************************************/
/***        Exported Variables                                            ***/
/****************************************************************************/

/****************************************************************************/
/***        Local Variables                                               ***/
/****************************************************************************/

/****************************************************************************/
/***        Exported Functions                                            ***/
/****************************************************************************/


/****************************************************************************
 *
 * NAME: APP_taskLed0
 *
 * DESCRIPTION:
 * Main state machine for the home sensor demo coordinator
 *
 * RETURNS:
 * void
 *
 ****************************************************************************/
OS_TASK(APP_taskLed0)
{
    static bool bLedState = OFF;
    DBG_vPrintf(TRACE_APP, "Led Task0\n");

    // Toggle the led
    bLedState = ~bLedState;

    // Prolong the task execution time
    volatile unsigned int i;
    for (i=0; i<0x7ffff; i++);

    // Set the led
    SET_LED(LED0,bLedState);

    /* flash again in 1 second */
    OS_eContinueSWTimer(APP_tmrFlashLed0, FLASH_TIME_0, NULL);

    DBG_vPrintf(TRACE_APP, "Terminating task0\n");

}

/****************************************************************************
 *
 * NAME: APP_taskLed1
 *
 * DESCRIPTION:
 * Main state machine for the home sensor demo coordinator
 *
 * RETURNS:
 * void
 *
 ****************************************************************************/
OS_TASK(APP_taskLed1)
{
    static bool bLedState = OFF;
    DBG_vPrintf(TRACE_APP, "Led Task1\n");

    // Toggle the led
    bLedState = ~bLedState;

    // Set the led
    SET_LED(LED1,bLedState);

    /* flash again in 360ms */
    OS_eContinueSWTimer(APP_tmrFlashLed1, FLASH_TIME_1, NULL);

    DBG_vPrintf(TRACE_APP, "Terminating task1\n");

}

/****************************************************************************/
/***        Local Functions                                               ***/
/****************************************************************************/

/****************************************************************************/
/***        END OF FILE                                                   ***/
/****************************************************************************/
